Packager: Igor Vlasenko <viy@altlinux.ru>
%define _with_bootstrap 1
%define _bootstrap 1
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap


Name:           buildmagic
Version:        2.0
Release:        alt1_0.20030518.2jpp5
Epoch:          0
Summary:        JBoss buildmagic tasks module
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -D 20030518 -d buildmagic-2.0 buildmagic
# tar cjf buildmagic-2.0.tar.bz2 buildmagic-2.0
Source0:        buildmagic-2.0.tar.bz2
Patch0:         buildmagic-no-jboss-common-classes.patch
Patch1:         buildmagic-ant16-ant17.patch
Patch2:         buildmagic-httpurl.patch
Patch3:         buildmagic-jmxdoclet.patch
Patch4:         buildmagic-java5-enum.patch
Provides:       %{name}-tasks = %{epoch}:%{version}-%{release}
Requires: bsf
Requires: log4j
BuildRequires: ant >= 0:1.6
BuildRequires: ant-nodeps
BuildRequires: bsf
%if %without bootstrap
BuildRequires: buildmagic
%endif
BuildRequires: dom4j
BuildRequires: gnu-regexp
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-slide-webdavclient
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: junit
BuildRequires: log4j
BuildRequires: xdoclet
BuildArch:      noarch

%description
Buildmagic tasks module of JBoss.

%prep
%setup -q
%if %with bootstrap
%patch0 -p1
%endif
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
find . -type f -name "*.jar" | xargs -t rm
find tasks/src -type f -name "*.java" | xargs -t %{__sed} -i -e 's|com\.ibm\.bsf|org\.apache\.bsf|g'
find . -type f -name task.properties | xargs -t %{__sed} -i -e  's|\(^javac\.source=.*$\)|#\1|g'
%if %with bootstrap
%{__mkdir_p} tasks/src/main/org/jboss/util/file
%{__mkdir_p} tasks/src/main/org/jboss/util/platform
%{__mkdir_p} tasks/src/main/org/jboss/util/stream
%{__mkdir_p} tasks/src/main/org/jboss/logging
%{__cp} -p common/src/main/org/jboss/util/DirectoryBuilder.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/Strings.java tasks/src/main/org/jboss/util
%{__sed} -i -e 's/org\.jboss\.util\.platform\.Constants\.LINE_SEPARATOR/System.getProperty("line.separator")/' tasks/src/main/org/jboss/util/Strings.java
%{__cp} -p common/src/main/org/jboss/util/NestedError.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/NestedThrowable.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/ThrowableHandler.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/ThrowableListener.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/NullArgumentException.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/EmptyStringException.java tasks/src/main/org/jboss/util
%{__cp} -p common/src/main/org/jboss/util/file/Files.java tasks/src/main/org/jboss/util/file
%{__cp} -p common/src/main/org/jboss/util/platform/Java.java tasks/src/main/org/jboss/util/platform
%{__cp} -p common/src/main/org/jboss/util/stream/Streams.java tasks/src/main/org/jboss/util/stream
%{__cp} -p common/src/main/org/jboss/logging/Logger.java tasks/src/main/org/jboss/logging
%{__cp} -p common/src/main/org/jboss/logging/LoggerPlugin.java tasks/src/main/org/jboss/logging
%{__cp} -p common/src/main/org/jboss/logging/NullLoggerPlugin.java tasks/src/main/org/jboss/logging
%else
%{__ln_s} $(build-classpath buildmagic) tools/lib/buildmagic-tasks.jar
%endif

%build
export CLASSPATH=$(build-classpath bsf log4j)
export OPT_JAR_LIST="ant/ant-nodeps"
%if %with bootstrap
pushd tasks
%{ant} \
        -Djavac.optimize=off \
        -Djavac.target=1.5 \
        -Djavac.debug=off \
        -Djavac.depend=no \
        -Djavac.verbose=no \
        -Djavac.deprecation=on \
        -Djavac.include.ant.runtime=yes \
        -Djavac.include.java.runtime=no \
        -Djavac.fail.onerror=true \
        -Djavac.includes=**/*.java \
        -Dsource.java=src \
        -Dsource.etc=src/etc \
        -Dsource.resources=src/resources \
        -Dbuild.classes=output/classes \
        -Dbuild.gen.classes=output/gen/classes \
        -Dbuild.etc=output/etc \
        -Dbuild.resources=output/resources \
        -Dbuild.lib=output/lib \
        -Dinit.disable=true \
        -Ddependency-manager.offline=true \
        -Dbuild.sysclasspath=only \
        output
popd
%endif

XDOCLET_CLASSES=$(build-classpath xdoclet/xdoclet xdoclet/xdoclet-jmx-module xjavadoc jakarta-commons-collections jakarta-commons-logging)
export CLASSPATH=${CLASSPATH}:`pwd`/tasks/output/lib/buildmagic-tasks.jar:$(build-classpath dom4j gnu-regexp jakarta-commons-httpclient slide/jakarta-slide-webdavlib junit):${XDOCLET_CLASSES}
%if %with bootstrap
export CLASSPATH=${CLASSPATH}:`pwd`/common/output/classes
%else
export CLASSPATH=${CLASSPATH}:$(build-classpath buildmagic-tasks)
%endif
export OPT_JAR_LIST="ant/ant-nodeps"
pushd build
ant -Dant.version="`%{_bindir}/ant -version`" -Dbuild.sysclasspath=first
popd

%install

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p tasks/output/lib/buildmagic-tasks.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%{__ln_s} %{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-tasks-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

%files
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-tasks-%{version}.jar
%{_javadir}/%{name}-tasks.jar

%changelog
* Tue Mar 17 2009 Igor Vlasenko <viy@altlinux.ru> 0:2.0-alt1_0.20030518.2jpp5
- first build (with bootstrap)

